#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 1000002;
const int MAX_4N = 2000008;
const int INF = 1e9+2;
const int MOD = 1e9+7;
long long ans;
int n;
int tree[MAX_4N];
int a[MAX_N];
int dp_left2[MAX_N];
int dp_right2[MAX_N];
int q;
int c;
void build(int node, int tl, int tr)
{
    if(tl==tr)
    {
        tree[node] = a[tl];
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    tree[node] = min(tree[node*2], tree[node*2+1]);
    return;
}
int query(int node, int tl, int tr, int l, int r)
{
    if(tl > r || tr < l) return INF;
    if(tl >= l && tr <= r)
    {
        return tree[node];
    }
    int mid = (tl+tr)/2;
    return (min(query(node*2,tl,mid,l,r),query(node*2+1,mid+1,tr,l,r)));
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>c;
        cin>>c;
    }
    build(1,0,n-1);
    for(int i=0; i<n; i++)
    {
        int left2 = 0;
        int right2 = i-1;
        int last = i;
        while(left2 <= right2)
        {
            int middle = (right2+left2)/2;
            int val = query(1,0,n-1,middle,right2);
            if(val >= a[i])
            {
                last = middle;
                right2 = middle-1;
            }
            else left2 = middle+1;
        }
        dp_left2[i] = i-last+1;
    }
    for(int i=0; i<n; i++)
    {
        int left2 = i+1;
        int right2 = n-1;
        int last = i;
        while(left2 <= right2)
        {
            int middle = (right2+left2)/2;
            int val = query(1,0,n-1,left2,middle);
            if(val > a[i])
            {
                last = middle;
                left2 = middle+1;
            }
            else right2 = middle-1;
        }
        dp_right2[i] = last-i+1;
    }
    for(int i=0; i<n; i++)
    {
        ans+=(long long)dp_left2[i]*dp_right2[i]*a[i];
        ans%=MOD;
    }
    cout<<ans<<endl;
}
