#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAX = 1000000;

bool e[MAX + 5];
long long pr[MAX + 5];
int mx[MAX + 5], st[MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    vector<int> p;
    p.push_back(0);
    for (int i = 2; i <= MAX; ++ i)
    {
        if (!e[i])
        {
            p.push_back(i);
            for (long long j = 1ll * i * i; j <= MAX; j += i)
            {
                e[j] = true;
            }
        }
    }

    int sz = p.size() - 1;
    for (int i = 1; i <= sz; ++ i)
    {
        pr[i] = pr[i - 1] + p[i];
    }

    for (int i = 1; i <= sz; ++ i)
    {
        for (int j = 1; j <= sz - i + 1; ++ j)
        {
            long long s = pr[j + i - 1] - pr[j - 1];
            if (s > MAX) break;
            mx[s] = i;
            st[s] = j;
        }
    }

    int a, b;
    cin >> a >> b;

    int ans = 0;
    for (int i = a; i <= b; ++ i)
    {
        if (!e[i])
        {
            if (mx[i] > mx[ans])
            {
                ans = i;
            }
        }
    }

    if (ans == 0) cout << "no primes" << endl;
    else
    {
        cout << ans << " " << mx[ans] << endl;
        for (int i = st[ans]; i < st[ans] + mx[ans]; ++ i)
        {
            cout << p[i] << " ";
        }
        cout << endl;
    }

    return 0;
}
