#include<bits/stdc++.h>
using namespace std;

const int MAXN = 20000;

bool visited[20000];
int loop[200000];
bool DFS(int i, vector<int> g[])
{
    if(loop[i] != -1) return loop;
    if(visited[i]) return false;
    bool ret = true;
    visited[i] = true;
    for(int e: g[i])
    {
        ret = ret && DFS(e, g);
        if(!ret)
        {
            return false;
        }
    }
    visited[i] = false;
    return loop[i] = ret;
}

void Solve()
{
    int n, m, a[MAXN], t;
    int mm[MAXN+1], mc = 0;
    memset(mm, -1, sizeof(mm));
    vector<int> g[MAXN];
    scanf("%d", &n);
    for(int i = 0; i < n; i++)
    {
        scanf("%d", &m);
        for(int j = 0; j < m; j++)
        {
            scanf("%d", &a[j]);
            if(mm[a[j]] == -1) mm[a[j]] = mc++;
            a[j] = mm[a[j]];
            if(j - 1 >= 0) g[a[j]].push_back(a[j-1]);
        }
    }
    vector<int>::iterator it;
    for(int i = 0; i < mc; i++)
    {
        sort(g[i].begin(), g[i].end());
        it = unique(g[i].begin(), g[i].end());
        g[i].resize(distance(g[i].begin(), it));
    }
    memset(visited, 0, sizeof(visited));
    memset(loop, -1, sizeof(loop));
    bool p;
    for(int i = 0; i < mc; i++)
    {
        p = DFS(i, g);
        if(!p)
        {
            printf("0\n");
            return;
        }
    }
    printf("1\n");
}

int main()
{
    for(int i = 0; i < 5; i++)
        Solve();
    return 0;
}
