#include<iostream>
#include<map>
#include<vector>

using namespace std;

class node
{
public:
    int index;

    vector<int> last;
    vector<int> next;
};

const int nodesSize = 50000;

bool visited[nodesSize];

bool found = false;

void recursion(int nodeNow, vector<node>& publicNodes)
{
    if(found == true)
    {
        return;
    }

    for(int i = 0;i < publicNodes[nodeNow].last.size();i++)
    {
        if(visited[publicNodes[nodeNow].last[i]] == true)
        {
            found = true;
            return;
        }

        visited[publicNodes[nodeNow].last[i]] = true;
        recursion(publicNodes[nodeNow].last[i], publicNodes);
        visited[publicNodes[nodeNow].last[i]] = false;
    }
}

void printVector(vector<int> print)
{
    for(int i = 0;i < print.size();i++)
    {
        cout<<print[i]<<" ";
    }
}

bool test()
{
    found = false;

    map<int, int> m;

    int n;
    cin>>n;

    int k[n];

    int input[n][nodesSize];

    for(int i = 0;i < n;i++)
    {
        cin>>k[i];

        for(int j = 0;j < k[i];j++)
        {
            cin>>input[i][j];

            m[input[i][j]] = 0;
        }
    }

    int maxIndx = 1;

    for(int i = 0;i < n;i++)
    {
        for(int j = 0;j < k[i];j++)
        {
            if(m[input[i][j]] == 0)
            {
                m[input[i][j]] = maxIndx;

                maxIndx++;
            }

            input[i][j] = m[input[i][j]];
        }
    }

    for(int i = 0;i < n;i++)
    {
        for(int j = 0;j < k[i];j++)
        {
            input[i][j]--;
            //cout<<input[i][j]<<" ";
        }
        //cout<<endl;
    }

    maxIndx--;

    vector<node> nodes;

    for(int i = 0;i < maxIndx;i++)
    {
        node p;
        p.index = i;

        nodes.push_back(p);
    }

    for(int i = 0;i < n;i++)
    {
        for(int j = 0;j < k[i] - 1;j++)
        {
            nodes[input[i][j]].next.push_back(input[i][j + 1]);
            nodes[input[i][j + 1]].last.push_back(input[i][j]);
        }
    }
/*
    for(int i = 0;i < maxIndx;i++)
    {
        cout<<i<<endl;
        cout<<nodes[i].last.size()<<endl;
        cout<<nodes[i].next.size()<<endl;
        printVector(nodes[i].last);
        cout<<endl;
        printVector(nodes[i].next);
        cout<<endl;
        cout<<"----------"<<endl;
    }*/

    for(int i = 0;i < maxIndx;i++)
    {
        visited[i] = true;
        for(int j = 0;j < nodes[i].last.size();j++)
        {
            recursion(nodes[i].last[j], nodes);
        }

        visited[i] = false;

        if(found)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    int res[5];
    for(int i = 0;i < 5;i++)
    {
        res[i] = test();
    }

    for(int i = 0;i < 5;i++)
    {
        cout<<res[i]<<endl;
    }
}
