#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? 1, a = b : 0;}

template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? 1, a = b : 0;}

const ll mod = 1e9 + 7;



const int MAX_N = 1e6 + 10;

vector<int> g[MAX_N];

int used[MAX_N];



void init() {

    for(int i = 0; i < MAX_N; i ++) {

        g[i].resize(0);

        used[i] = 0;

    }

}



int k;



bool dfs(int x) {

    used[x] = 1;

    for(auto it : g[x]) {

        if(used[it] == 1) {

            return true;

        } else if(used[it] == 0) {

            if(dfs(it)) {

                return true;

            }

        }

    }

    used[x] = 2;

    return false;

}



void input() {

    cin >> k;

    for(int i = 0; i < k; i ++) {

        int n;

        cin >> n;

        int last = -1;

        for(int j = 0; j < n; j ++) {

            int a;

            cin >> a;

            if(last != -1) {

                g[last].push_back(a);

            }

            last = a;

        }

    }

    for(int i = 0; i < MAX_N; i ++) {

        if(used[i] == 0 && dfs(i)) {

            cout << 0 << endl;

            return;

        }

    }

    cout << 1 <<  endl;

}



signed main() {

    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    init();

    input();

    return 0;

}

/*

2

3 1 2 3

4 1 3 5 6



3

3 5 1 4

3 4 201 150

4 150 1 20 55



2

4 1 5 6 2

3 2 1 6



4

5 100 20 45 10 3

3 20 300 400

4 500 100 80 10

3 400 500 1000



3

3 1 80 5

5 90 1 4 8 80

5 90 1 8 100 5

*/
