#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 32000;

int ans;

int k, n;
int u, v;
vector<int> sys[MAXN];
int numtovertex[MAXN], vertexc;

int inQ[MAXN];
void dfs(int curr)
{
    inQ[curr] = 1;
    for(int i = 0; i < sys[curr].size() && ans == 1; i++){
        int to = sys[curr][i];
        if(inQ[to] == 1){
            ans = 0;
            return;
        }
        if(inQ[to] == 0){
            dfs(to);
        }
    }
    inQ[curr] = 2;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ans = 1;

    cin >> k;
    for(int i = 0; i < k; i++){
        cin >> n;
        cin >> u;
        if(numtovertex[u] == 0){
            vertexc++;
            numtovertex[u] = vertexc;
        }
        u = numtovertex[u];
        for(int j = 1; j < n; j++){
            cin >> v;
            if(numtovertex[v] == 0){
                vertexc++;
                numtovertex[v] = vertexc;
            }
            v = numtovertex[v];
            sys[u].push_back(v);
            u = v;
        }
    }

    for(int i = 1; i <= vertexc; i++){
        if(inQ[i] == 0){
            dfs(i);
        }
        if(ans == 0){
            break;
        }
    }

    cout << ans << endl;
    return 0;
}
