#include <bits/stdc++.h>
using namespace std;

const long long mod = 1000000007;
long long tree[1000002];
long long n, measure, q, m[1000002], pr[1000002], curr, a[1000002], ind, novo;
vector <pair <int, int> > v;

void put (int idx, long long value) {
    for (int i=idx; i <= 1000000; i += (i & (-i))) {
        if (i > 1000000) {break;}
        //cout << i << endl;
        tree[i] = max (tree[i], value);
    }
}

long long query (int idx) {
    long long ans=0;
    for (int i=idx; i > 0; i -= (i & (-i))) {
        //cout << i << endl;
        if (i < 0) {break;}
        ans = max (ans, tree[i]);
    }
    return ans;
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

cin >> n;

for (int i=1; i <= n; i++) {
    cin >> a[i];
    put (a[i], i);
    m[i] += a[i];
    long long x = query (a[i]-1);
    //cout << i << " " << x << endl;
    m[i] += (((i-x-1)*a[i]%mod) + (m[x]%mod)%mod);
    //cout << i << " " << m[i] << endl;
    measure = (measure + m[i]) % mod;
    pr[i] = (pr[i-1] + m[i])%mod;
    //cout << i << " pr: " << pr[i] << endl;
}

cin >> q;

for (int i=0; i < q; i++) {
    cin >> ind >> novo;
    v.push_back({ind+1, novo});
}

sort (v.begin(), v.end());

memset (tree, 0, sizeof(tree));

long long p=1;

for (int i=0; i < q; i++) {
    //cout << "now " << v[i].first << " " << v[i].second << endl;
    while (p < v[i].first) {
        put (a[p], p);
        p++;
    }
    measure = (measure + pr[v[i].first-1])%mod;
    //cout << "purvo " << pr[v[i].first-1] << endl;
    long long x = query (v[i].second-1);
    //cout << x << endl;
    //cout << i << " " << x << endl;
    //m[i] += (((v[i].first-x-1)*v[i].second%mod) + (m[x]%mod)%mod);
    //cout << i << " " << m[i] << endl;
    measure = (measure + ((v[i].first-x-1)*v[i].second%mod) + v[i].second + m[x]) % mod;
    //pr[i] = (pr[i-1] + m[i])%mod;
    //cout << "taka " << measure << endl;
}

cout << measure%mod << endl;

return 0;
}
