#include <iostream>
#include <vector>
#include <stack>
using namespace std;
#define endl '\n'
const int MAXN=2e4+10;
vector <int> v[MAXN], op[MAXN];
int a[MAXN];
bool used[MAXN];
stack <int> st;
void dfs(int x) {
    used[x]=true;
    for (auto i:v[x]) {
        if (used[i]) continue;
        dfs(i);
    }
    st.push(x);
}
void dfs_op(int x) {
    used[x]=true;
    for (auto i:op[x]) {
        if (used[i]) continue;
        dfs_op(i);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int k, len, maxs=0;
    cin >> k;
    for (int i=0;i<k;i++) {
        cin >> len;
        for (int j=0;j<len;j++) {
            cin >> a[j];
            maxs=max(maxs,a[j]);
            if (j==0) continue;
            v[a[j-1]].push_back(a[j]);
            op[a[j]].push_back(a[j-1]);
        }
    }
    for (int i=1;i<=maxs;i++) {
        if (!used[i]) dfs(i);
    }
    for (int i=1;i<=maxs;i++) used[i]=false;
    int scc=0;
    while (!st.empty()) {
        if (!used[st.top()]) {
            dfs_op(st.top());
            scc++;
        }
        st.pop();
    }
    ///cout << scc << endl;
    if (scc==maxs) cout << 1 << endl;
    else cout << 0 << endl;
    return 0;
}
/**
2
3 1 2 3
4 1 3 5 6
**/
