#include <iostream>
#include <stack>
using namespace std;
#define endl '\n'
const long long mod=1e9+7;
const int MAXN=1e6+10;
stack <int> st;
long long a[MAXN], l[MAXN], r[MAXN];
long long modul(long long s) {
    if (s<mod) return s;
    return s%mod;
}
long long brsums(long long beg, long long i, long long e) {
    if (beg==i && e==i) return 0;
    return modul((i-beg)*(e-i));
}
long long find_ans(int n) {
    for (int i=0;i<n;i++) {
        l[i]=-1; r[i]=n;
    }
    while (!st.empty()) st.pop();
    for (int i=0;i<n;i++) {
        while (!st.empty() && a[i]<a[st.top()]) {
            r[st.top()]=i;
            st.pop();
        }
        if (!st.empty()) l[i]=st.top();
        else l[i]=-1;
        st.push(i);
    }
    long long ans=0, s;
    for (long long i=0;i<n;i++) {
        ///cout << a[i] << ' ' << l[i] << ' ' << r[i] << ' ' << brsums(l[i],i,r[i]) << endl;
        s=brsums(l[i],i,r[i]);
        if (s<0) s=0;
        ans=modul(ans+a[i]*s);
    }
    return ans;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) cin >> a[i];
    int q, ind, val;
    cin >> q;
    long long ans=find_ans(n), s;
    for (int i=0;i<q;i++) {
        cin >> ind >> val;
        a[ind]=val;
        s=find_ans(ind+1);
        ans=modul(ans+s);
    }
    cout << ans << endl;
    return 0;
}
/**
7
2 3 4 2 2 3 1
0
**/
