#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
#define endl '\n'
const int MAXN=1e6+10;
bool er[MAXN];
long long pref[MAXN];
vector <long long> pr;
unordered_map <long long, pair<int,int> > sum;
void eratosten(long long gr) {
    er[1]=true;
    for (int i=4;i<=gr;i+=2) er[i]=true;
    pr.push_back(2);
    for (long long i=3;i<=gr;i+=2) {
        if (!er[i]) {
            pr.push_back(i);
            for (long long j=i*i;j<=gr;j+=2*i) er[j]=true;
        }
    }
}
long long interval(int i, int j) {
    if (j==0) return pref[i];
    return pref[i]-pref[j-1];
}
pair <int,int> bs(int i, long long s) {
    int l, r, mid;
    l=0; r=i;
    while (l<=r) {
        mid=(l+r)/2;
        if (interval(i,mid)>s) l=mid+1;
        else r=mid-1;
    }
    return make_pair(interval(i,l),i-l+1);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long a, b;
    cin >> a >> b;
    eratosten(b);
    pair <int,int> s;
    int num=-1, ans=0, beg;
    for (int i=0;i<pr.size();i++) {
        if (i==0) pref[i]=pr[i];
        else pref[i]=pref[i-1]+pr[i];
        s=bs(i,b);
        if (sum[s.first].second<s.second && !er[s.first]) {
            sum[s.first]={i,s.second};
            if (s.first>=a && s.second>ans) {
                num=s.first;
                ans=sum[s.first].second;
                beg=sum[s.first].first;
            }
        }
    }
    if (num==-1) {
        cout << "no prime\n";
        return 0;
    }
    cout << num << ' ' << ans << endl;
    for (int i=beg-ans+1;i<=beg;i++) cout << pr[i] << ' ';
    cout << endl;
    return 0;
}
