#include <bits/stdc++.h>

const int MAXN = 2e5 + 10;

std::vector<int> nbrs[MAXN];
int inc[MAXN];

bool is[MAXN];

std::queue<int> q;

int main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int k;
    std::cin >> k;

    for(int i = 0; i < k; ++ i)
    {
        int ni, currnum, prevnum;
        std::cin >> ni;
        std::cin >> prevnum;
        for(int j = 1; j < ni; ++ j)
        {
            std::cin >> currnum;
            is[currnum] = true;
            nbrs[currnum].push_back(prevnum);
            ++ inc[prevnum];
            prevnum = currnum;

        }
    }

    for(int i = 0; i < MAXN; ++ i)
    {
        if(!is[i])
        {
            continue;
        }

        if(inc[i] == 0)
        {
            q.push(i);
        }
    }

    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        is[curr] = 0;

        for(int i = 0; i < nbrs[curr].size(); ++ i)
        {
            -- inc[nbrs[curr][i]];
            if(!inc[nbrs[curr][i]])
            {
                q.push(nbrs[curr][i]);
            }
        }
    }

    for(int i = 0; i < MAXN; ++ i)
    {
        if(is[i])
        {
            std::cout << "0\n";
            return 0;
        }
    }

    std::cout << "1\n";

    return 0;
}
