#include <bits/stdc++.h>

#define int long long

const int MAXN = 1e6 + 10, mod = 1e9 + 7;

int arr[MAXN], left[MAXN], right[MAXN], ans, anses[MAXN], mins[MAXN], answer;
std::stack<int> q;

signed main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int n, t;
    std::cin >> n;

    for(int i = 1; i <= n; ++ i)
    {
        std::cin >> arr[i];
    }
    std::cin >> t;

    if(!t)
    {
        for(int i = 1; i <= n; ++ i)
        {
            while(!q.empty() && arr[q.top()] > arr[i])
            {
                right[q.top()] = i;
                q.pop();
            }
            left[i] = q.empty() ? 0 : q.top();
            q.push(i);
        }

        while(!q.empty())
        {
            right[q.top()] = n + 1;
            q.pop();
        }

        for(int i = 1; i <= n; ++ i)
        {
            ans += arr[i] * (i - left[i]) * (right[i] - i);
            ans %= mod;
        }

        std::cout << ans << '\n';

        return 0;
    }

    for(int i = 1; i <= n; ++ i)
    {
        anses[i] = (anses[i - 1] + arr[i]) % mod;

        int curr = i - 1;
        bool is = false;
        while(curr != 0)
        {
            if(!is &&arr[curr] < arr[i])
            {
                left[i] = curr;
                is = true;
            }
            if(is)
            {
                anses[i] += arr[curr] * (curr - left[curr]);
                anses[i] %= mod;
            }else
            {
                anses[i] += arr[i] * (curr - left[curr]);
                anses[i] %= mod;
            }
            curr = left[curr];
        }

        //std::cout << anses[i] << '\n';
    }

    /*for(int i = 1; i <= n; ++ i)
    {
        std::cout << left[i] << ' ';
    }std::cout << '\n';*/

    answer = anses[n];

    while(t --)
    {
        int i, val;
        std::cin >> i >> val;
        ++ i;

        ans = anses[i - 1] + val;
        ans %= mod;

        int curr = i - 1;
        bool is = false;
        while(curr != 0)
        {
            if(arr[curr] < val)
            {
                //left[i] = curr;
                is = true;
            }
            if(is)
            {
                ans += arr[curr] * (curr - left[curr]);
                ans %= mod;
            }else
            {
                ans += val * (curr - left[curr]);
                ans %= mod;
            }
            curr = left[curr];
        }

        //std::cout << ans << '\n';
        answer = (answer + ans) % mod;
    }

    std::cout << answer << '\n';

    return 0;
}
