#include <bits/stdc++.h>

const int MAXN = 1e6;

bool is[MAXN];

long long ans[MAXN], sums[MAXN / 10];

std::vector<int> primes;

int main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int a, b;
    std::cin >> a >> b;

    for(int i = 2; i < MAXN; ++ i)
    {
        if(!is[i])
        {
            primes.push_back(i);
        }
        for(int j = i * 2; j < MAXN; j += i)
        {
            is[j] = true;
        }
    }

    sums[0] = 2;
    for(int i = 1; i < primes.size(); ++ i)
    {
        sums[i] = sums[i - 1] + primes[i];
        if(sums[i] < MAXN && !is[sums[i]] && ans[sums[i]] < i)
        {
            ans[sums[i]] = i + 1;
        }
        for(int j = (i - 1) % 2; j < i; j += 2)
        {
            if(sums[i] - sums[j] >= MAXN)
            {
                break;
            }
            if(!is[sums[i] - sums[j]] && ans[sums[i] - sums[j]] < i - j)
            {
                ans[sums[i] - sums[j]] = i - j;
            }
        }
    }

    int max = 0, maxi;

    for(int i = a; i <= b; ++ i)
    {
        if(ans[i] > max)
        {
            max = ans[i];
            maxi = i;
        }
    }

    if(!max)
    {
        std::cout << "no prime\n";
        return 0;
    }

    std::cout << maxi << ' ' << max << '\n';

    if(sums[max - 1] == maxi)
    {
        for(int i = 0; i < max; ++ i)
        {
            std::cout << primes[i] << ' ';
        }
        std::cout << '\n';
        return 0;
    }

    for(int i = 0; 1; ++ i)
    {
        if(sums[i + max] - sums[i] == maxi)
        {
            for(int j = i + 1; j <= i + max; ++ j)
            {
                std::cout << primes[j] << ' ';
            }
            std::cout << '\n';
            return 0;
        }
    }

    return 0;
}

