#include<iostream>
#include<vector>
#include<cmath>
using namespace std;

struct DanniZaSbora{
    long long sbor;
    int tip;
};

long long otKade;
long long doKade;

vector<long long> redicaSasSbor[1000010];

bool sastavnoLIE[1000010];

vector<DanniZaSbora> napraveniMinaliqPatRedici;
vector<DanniZaSbora> napraveniToqPatRedici;

vector<long long> prostiteChislaVIntervala;

void eratosten(){
    sastavnoLIE[0] = true;
    sastavnoLIE[1] = true;

    for(long long i = 2; i <= doKade; i++){
        if(sastavnoLIE[i] == false){
            if(i >= otKade){
                prostiteChislaVIntervala.push_back(i);
            }

            /*cout<<i<<":"<<endl;

            cout<<"sborovete kouito imame ";
            for(DanniZaSbora j : napraveniMinaliqPatRedici){
                cout<<j.sbor<<" ";
            }
            cout<<endl;*/

            if(redicaSasSbor[i].size() == 0){
                //cout<<"namerih nov sbor "<<i<<endl;
                redicaSasSbor[i].push_back(i);
            }

            napraveniToqPatRedici.push_back({i, 2});

            for(long long j = 0; j < napraveniMinaliqPatRedici.size(); j++){
                long long novSbor = napraveniMinaliqPatRedici[j].sbor + i;
                if(novSbor > doKade){
                    break;
                }

                if(redicaSasSbor[novSbor].size() > 0){
                    //cout<<"veche imame dostatachnio dalga redica sas sbor "<<novSbor<<endl;
                    continue;
                }

                if(napraveniMinaliqPatRedici[j].tip == 1){
                    redicaSasSbor[novSbor] = redicaSasSbor[napraveniMinaliqPatRedici[j].sbor];
                }else{
                    //redicaSasSbor[novSbor] = {napraveniMinaliqPatRedici[j].sbor};
                    redicaSasSbor[novSbor].push_back(napraveniMinaliqPatRedici[j].sbor);
                }
                redicaSasSbor[novSbor].push_back(i);
                napraveniToqPatRedici.push_back({novSbor, 1});
                /*cout<<"namerih nov sbor "<<novSbor<<endl;
                cout<<"toi e sastaven ot ";
                for(auto h : redicaSasSbor[novSbor]){
                    cout<<h<<" ";
                }
                cout<<endl;*/
            }

            napraveniMinaliqPatRedici = napraveniToqPatRedici;
            napraveniToqPatRedici.clear();

            /*cout<<"napraveniq toq pat redici sa ";
            for(DanniZaSbora j : napraveniMinaliqPatRedici){
                cout<<j.sbor<<" ";
            }
            cout<<endl;*/

            for(long long x = i*i; x <= doKade; x+=i){
                sastavnoLIE[x] = true;
            }
        }
    }


}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>otKade>>doKade;

    eratosten();

    long long sNaiGolqmataDaljina = 0;
    long long kolkoENaiGolqmataDaljina = 0;

    for(long long j = 0; j < prostiteChislaVIntervala.size(); j++){
        long long i = prostiteChislaVIntervala[j];
        if(redicaSasSbor[i].size() > kolkoENaiGolqmataDaljina){
            kolkoENaiGolqmataDaljina = redicaSasSbor[i].size();
            sNaiGolqmataDaljina = i;
        }
    }

    if(sNaiGolqmataDaljina == 0){
        cout<<"no prime"<<endl;
    }else{
        cout<<sNaiGolqmataDaljina<<" "<<redicaSasSbor[sNaiGolqmataDaljina].size()<<endl;
        for(long long i = 0; i < redicaSasSbor[sNaiGolqmataDaljina].size(); i++){
            cout<<redicaSasSbor[sNaiGolqmataDaljina][i]<<" ";
        }
        cout<<endl;
    }

    return 0;
}
