#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#define endl "\n"
typedef long long ll;
using namespace std;

const ll maxn=2*1e4+10;
vector<ll> sysedi[maxn],minati;
bool prazen[maxn],overall[maxn];
bool stava=true;
ll k,n,N[maxn],i,j;

void dfs(bool used[maxn], ll curr){
    if(!stava){
        return;
    }
    overall[curr]=true;
    used[curr]=true;
    minati.push_back(curr);
    ll z;
    for(z=0;z<sysedi[curr].size();z++){
        if(used[sysedi[curr][z]]){
            stava=false;
            return;
        }
        if(!overall[N[i]]){
            dfs(used,sysedi[curr][z]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> k;
    while(k>0){
        cin >> n;
        for(i=0;i<n;i++){
            cin >> N[i];
        }
        for(i=0;i<n;i++){
            for(j=i+1;j<n;j++){
                sysedi[N[i]].push_back(N[j]);
            }
        }
        for(i=0;i<n;i++){
            if(!overall[N[i]]){
                dfs(prazen,N[i]);
            }
            for(j=0;j<minati.size();j++){
                prazen[minati[j]]=false;
            }
            minati.clear();
        }
        k--;
    }
    if(stava){
        cout << 1 << endl;
    }else{
        cout << 0 << endl;
    }
    return 0;
}



