#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 1000005
int er[MAXN];
vector<int> primes;
int prefix[MAXN];
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    for(int i = 2; i < MAXN; ++i){
        if(er[i]) continue;
        primes.push_back(i);
        for(int z = i * i; z < MAXN; z += 2 * i){
            er[z] = 1;
            if(i == 2) er[z - i] = 1;
        }
    }
    for(int i = 0; i < primes.size(); ++i){
        if(i == 0) prefix[i] = primes[i];
        else prefix[i] = prefix[i - 1] + primes[i];
    }
    int a, b; cin >> a >> b;
    int num = -1, f = 0, r = -1;
    for(int i = 0; i < primes.size(); ++i){
        for(int z = i; z < primes.size(); ++z){
            int s;
            if(i == 0) s = prefix[z];
            else s = prefix[z] - prefix[i - 1];
            if(s > MAXN) break;
            if(er[s] == 0){
                if(s >= a && s <= b && (z - i) > (r - f)){
                    num = s; f = i; r = z;
                }
            }
        }
    }
    if(num == -1){
        cout << "no prime\n"; return 0;
    }
    cout << num << ' ' << r - f + 1 << endl;
    for(int i = f; i <= r; ++i){
        cout << primes[i] << ' ';
    }
    cout << endl;
    return 0;
}

