#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 1e6+2;
const int MAX_4N = 4e6+2;
const int INF = 1e9+2;
const int MOD = 1e9+7;
long long ans;
int tree[MAX_4N];
int a[MAX_N];
int dp_left[MAX_N];
int dp_right[MAX_N];
int q;
int c;
void build(int node, int tl, int tr)
{
    if(tl > tr) return;
    if(tl == tr)
    {
        tree[node] = a[tl];
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    tree[node] = min(tree[node*2], tree[node*2+1]);
}
int query(int node, int tl, int tr, int l, int r)
{
    if(tl > tr) return INF;
    if(tl > r || tr < l) return INF;
    if(tl >= l && tr <= r)
    {
        return tree[node];
    }
    int mid = (tl+tr)/2;
    return min(query(node*2,tl,mid,l,r),query(node*2+1,mid+1,tr,l,r));
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>a[i];
    }
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>c;
        cin>>c;
    }
    build(1,0,n-1);
    cout<<0/5<<endl;
    for(int i=0; i<n; i++)
    {
        int left = 0;
        int right = i-1;
        int last = i;
        while(left <= right)
        {
            int middle = (right+left)/2;
            int val = query(1,0,n-1,middle,right);
            if(val >= a[i])
            {
                last = middle;
                right = middle-1;
            }
            else left = middle+1;
        }
        dp_left[i] = i-last+1;
    }
    for(int i=0; i<n; i++)
    {
        int left = i+1;
        int right = n-1;
        int last = i;
        while(left <= right)
        {
            int middle = (right+left)/2;
            int val = query(1,0,n-1,left,middle);
            if(val > a[i])
            {
                last = middle;
                left = middle+1;
            }
            else right = middle-1;
        }
        dp_right[i] = last-i+1;
    }
    for(int i=0; i<n; i++)
    {
        ans+=(long long)dp_left[i]*dp_right[i]*a[i];
        ans%=MOD;
    }
    cout<<ans<<endl;
}
