#pragma GCC optimize("O3")
#pragma GCC target("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) (-idx) & (idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) ->  how many elements are smaller than x

const int MAXN = 2e4 + 4;

ll T;
row low, instack, disc;
stack<ll> s;
matrix G(MAXN);

void dfs_scc(int u){
    disc[u] = low[u] = T ++;
    s.push(u);
    instack[u] = true;
    for(auto v : G[u]){
        if(disc[v] == -1){
            dfs_scc(v);
            low[u] = min(low[u], low[v]);
        }
        else if(instack[v]){
            low[u] = min(low[u], low[v]);
        }
    }
    while(!s.empty()){
        auto v = s.top();
        s.pop();
        low[v] = low[u];
        instack[v] = false;
        if(u == v){
            break;
        }
    }
}

int main(){
    ///ios_base::sync_with_stdio(false); cin.tie(NULL);
    int k; cin >> k;
    disc = row(MAXN, -1);
    low = row(MAXN, -1);
    instack = row(MAXN, 0);
    row tag(MAXN);
    for(int i = 0; i < k; i ++){
        int n; cin >> n;
        row A(n);
        for(int j = 0; j < n; j ++) cin >> A[j];
        for(int j = 0; j < n - 1; j ++){
            tag[A[j]] = true;
            tag[A[j + 1]] = true;
            G[A[j + 1]].pb(A[j]);
        }
    }
    for(int i = 0; i < MAXN; i ++){
        if(tag[i] && disc[i] == -1){
            dfs_scc(i);
        }
    }
    set<ll> tmp;
    for(int i = 0; i < MAXN; i ++){
        if(tag[i]){
            /// cout << i << " = " << low[i] << endl;
            tmp.insert(low[i]);
        }
    }
    cout << (count(all(tag), true) == tmp.size() ? 1 : 0) << endl;
}
/**
2
3 1 2 3
4 1 3 5 6
1

3
3 5 1 4
3 4 201 150
4 150 1 20 55
0

2
4 1 5 6 2
3 2 1 6
0

4
5 100 20 45 10 3
3 20 300 400
4 500 100 80 10
3 400 500 1000
0

3
3 1 80 5
5 90 1 4 8 80
5 90 1 8 100 5
1
*/
