#pragma GCC optimize("O3")
#pragma GCC target("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) (-idx) & (idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) ->  how many elements are smaller than x

const ll MOD = 1e9 + 7;
const ll MAXN = 1e6 + 6;

int segmtree[4 * MAXN];

void upd(ll node, ll l, ll r, ll x, ll v){
    if(l == r){
        segmtree[node] = v;
    }
    else{
        ll m = (l + r) / 2;
        if(l <= x && x <= m) upd(2 * node + 0, l + 0, m, x, v);
        else                 upd(2 * node + 1, m + 1, r, x, v);
        segmtree[node] = max(segmtree[2 * node], segmtree[2 * node + 1]);
    }
}

ll qry(ll node, ll l, ll r, ll ql, ll qr){
    if(qr < l || r < ql){
        return 0;
    }
    else if(ql <= l && r <= qr){
        return segmtree[node];
    }
    else{
        ll m = (l + r) / 2;
        ll q1 = qry(2 * node + 0, l + 0, m, ql, qr);
        ll q2 = qry(2 * node + 1, m + 1, r, ql, qr);
        return max(q1, q2);
    }
}

void upd(ll x, ll v){ upd(1, 1, MAXN, x, v); }
ll qry(ll l, ll r){ return qry(1, 1, MAXN, l, r); }

int main(){
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    int n; cin >> n;
    row A(n + 1);
    for(int i = 1; i <= n; i ++) cin >> A[i];
    row answers(n + 1);
    ll last = 0;
    upd(0, 0);
    for(int i = 1; i <= n; i ++){
        if(A[i] >= last){
            answers[i] = (answers[i - 1] + A[i]) % MOD;
        }
        if(A[i] < last){
            ll j = qry(1, A[i]);
            answers[i] = (answers[j] + ((i - j) * A[i]) % MOD) % MOD;
        }
        upd(A[i], i);
        last = A[i];
    }
    ll sum = 0;
    for(auto x : answers) sum = (sum + x) % MOD;
    cout << sum << endl;
}
