#pragma GCC optimize("O3")
#pragma GCC target("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) (-idx) & (idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) ->  how many elements are smaller than x

const ll MOD = 1e9 + 7;
const ll MAXN = 1e6 + 6;

ll BIT[MAXN];

void upd(ll x, ll v){
    for(; x < MAXN; x += bit(x)){
        BIT[x] = v;
    }
}

ll qry(ll x){
    ll ret = 0;
    for(; x > 0; x -= bit(x)){
        ret = max(ret, BIT[x]);
    }
    return ret;
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    ll n, last = 0, sum = 0, so_far = 0; cin >> n;
    row A(n + 1), answers(n + 1);
    vector<pair<pair<ll, bool>, ll>> queries;
    for(ll i = 1; i <= n; i ++) cin >> A[i];
    for(ll i = 1; i <= n; i ++){
        queries.pb({{i, true}, A[i]});
    }
    ll q; cin >> q;
    for(ll i = 0; i < q; i ++){
        ll x, v; cin >> x >> v;
        queries.pb({{x + 1, false}, v});
    }
    sort(all(queries));
    for(auto [query, x] : queries){
        ll pos = query.fr;
        bool flag = query.sc;
        ll curr = 0;
        if(x >= last){
            curr = (answers[pos - 1] + x) % MOD;
        }
        if(x < last){
            ll j = qry(x);
            curr = (answers[j] + ((pos - j) * x) % MOD) % MOD;
        }
        sum = (sum + curr) % MOD;
        if(flag){
            upd(x, pos);
            last = x;
            answers[pos] = curr;
            so_far = (so_far + curr) % MOD;
        }
        else{
            sum = (sum + so_far) % MOD;
        }
    }
    cout << sum << endl;
}
