#include <iostream>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAX = 20000;
const int MAXK = 100;

int n[MAX + 5];
int idx[MAX + 5];
int num[MAX + 5][MAXK + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    time_t start = clock();

    int k;
    cin >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> n[i];

        for (int j = 1; j <= n[i]; ++ j)
        {
            cin >> num[i][j];
        }
    }

    bool stop = false;
    while (!stop)
    {
        stop = true;
        for (int i = 1; i <= k; ++ i)
        {
            for (int j = 2; j <= n[i]; ++ j)
            {
                if (idx[num[i][j - 1]] > idx[num[i][j]])
                {
                    idx[num[i][j]] = idx[num[i][j - 1]] + (k - i + 1);
                    stop = false;
                }
            }
        }

        if (clock() - start >= 0.3 * CLOCKS_PER_SEC)
        {
            cout << 0 << endl;
            return 0;
        }
    }

    cout << 1 << endl;

    return 0;
}
