#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;
const long long MOD = (long long)(1e9 + 7);

int a[MAXN + 5];
int L[MAXN + 5], R[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    int q; /// q = 0
    cin >> q;

    stack<int> st;
    st.push(0);
    for (int i = 1; i <= n; ++ i)
    {
        while (a[st.top()] > a[i]) st.pop();
        L[i] = st.top() + 1;
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(n + 1);
    for (int i = n; i >= 1; -- i)
    {
        while (a[st.top()] >= a[i]) st.pop();
        R[i] = st.top() - 1;
        st.push(i);
    }

    long long sum = 0;
    for (int i = 1; i <= n; ++ i)
    {
        sum = (sum + (1ll * ((1ll * (i - L[i] + 1) * (R[i] - i + 1)) % MOD) * a[i]) % MOD) % MOD;
    }

    cout << sum << endl;

    return 0;
}
