#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
#define endl '\n'
const int MAXN=1e6+10;
bool er[MAXN];
int pref[MAXN];
vector <int> pr;
unordered_map <int, pair<int,int> > sum;
void eratosten(int gr) {
    for (int i=4;i<=gr;i+=2) er[i]=true;
    pr.push_back(2);
    for (long long i=3;i<=gr;i+=2) {
        if (!er[i]) {
            pr.push_back(i);
            for (long long j=i*i;j<=gr;j+=2*i) er[j]=true;
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a, b;
    cin >> a >> b;
    eratosten(b);
    bool ok=true;
    for (int i=a;i<=b;i++) if (!er[i]) ok=false;
    if (ok) {
        cout << "no prime\n";
        return 0;
    }
    for (int i=0;i<pr.size();i++) {
        pref[i]=0;
        for (int j=i;j>=0;j--) {
            pref[j]+=pr[i];
            if (pref[j]>b) break;
            if (!er[pref[j]]) {
                if (sum[pref[j]].second<i-j+1) sum[pref[j]]={i,i-j+1};
            }
        }
    }
    int num=-1, ans=0, beg;
    for (int i=a;i<=b;i++) {
        if (sum[i].second>ans) {
            num=i;
            ans=sum[i].second;
            beg=sum[i].first;
        }
    }
    cout << num << ' ' << ans << endl;
    for (int i=beg-ans+1;i<=beg;i++) cout << pr[i] << ' ';
    cout << endl;
    return 0;
}
