#include <bits/stdc++.h>

#define int long long

const int MAXN = 1e6 + 10, mod = 1e9 + 7;

int arr[MAXN], left[MAXN], right[MAXN], ans;
std::stack<int> q;

signed main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int n;
    std::cin >> n;

    for(int i = 1; i <= n; ++ i)
    {
        std::cin >> arr[i];

        while(!q.empty() && arr[q.top()] > arr[i])
        {
            right[q.top()] = i;
            q.pop();
        }
        left[i] = q.empty() ? 0 : q.top();
        q.push(i);
    }

    while(!q.empty())
    {
        right[q.top()] = n + 1;
        q.pop();
    }

    for(int i = 1; i <= n; ++ i)
    {
        ans += arr[i] * (i - left[i]) * (right[i] - i);
        ans %= mod;
    }

    int t;
    std::cin >> t;

    while(t --)
    {
        int a, b;
        std::cin >> a >> b;
    }

    std::cout << ans << '\n';

    return 0;
}
