#include<iostream>
#include<vector>

#define endl '\n'

using namespace std;

const int MOD=1e9+7;

void add_mod(int& x, int y){
    x+=y;
    if(x>=MOD){
        x-=MOD;
    }
}

int calc_measure(int n, vector<int>& nums){
    int res=0;

    for(int i=0;i<n;++i){
        int min_num=1e5+3;
        for(int j=i;j<n;++j){
            min_num=min(min_num, nums[j]);
            add_mod(res, min_num);
        }
    }

    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin>>n;

    vector<int> nums(n);
    for(int i=0;i<n;++i){
        cin>>nums[i];
    }

    int res=calc_measure(n, nums);

    int q;
    cin>>q;

    while(q--){
        int ind,val;
        cin>>ind>>val;

        int old_val=nums[ind];
        nums[ind]=val;

        add_mod(res, calc_measure(ind+1, nums));
        nums[ind]=old_val;
    }

    cout<<res<<endl;
return 0;
}
