#include<iostream>
#include<vector>
using namespace std;

int broiLinii;

int imaLiToziNomer[20010];
vector<int> nomerataKoitoGiIma;

vector<int> sasedstvo[20010];

int toziOtKoiEMarkiran[20010];
vector<int> segaMarkirani;
bool visited[20010];

void dfsZaMarkirane(int segashen, int kakMarkirame){
    if(visited[segashen] == true){
        return ;
    }

    toziOtKoiEMarkiran[segashen] = kakMarkirame;
    segaMarkirani.push_back(segashen);
    visited[segashen] = true;

    for(int i = 0; i < sasedstvo[segashen].size(); i++){
        dfsZaMarkirane(sasedstvo[segashen][i], kakMarkirame);
    }
}

bool proverkaVisited[20010];

bool sreshtameLiGo(int segashen, int koiTarsim){
    if(segashen == koiTarsim){
        return true;
    }

    if(proverkaVisited[segashen] == true){
        return false;
    }

    proverkaVisited[segashen] = true;

    bool zaVrasht = false;

    for(int i = 0; i < sasedstvo[segashen].size(); i++){
        bool tuka = sreshtameLiGo(sasedstvo[segashen][i], koiTarsim);

        if(tuka == true){
            zaVrasht = true;
            break;
        }
    }

    return zaVrasht;
}

void nulirane(){
    for(int i = 0; i < nomerataKoitoGiIma.size(); i++){
        visited[nomerataKoitoGiIma[i]] = false;
        proverkaVisited[nomerataKoitoGiIma[i]] = false;
    }
    segaMarkirani.clear();
}

int main(){
    cin>>broiLinii;

    for(int i = 0; i < broiLinii; i++){
        int broiTuka;
        cin>>broiTuka;

        int predishen;
        cin>>predishen;

        if(imaLiToziNomer[predishen] == 0){
            nomerataKoitoGiIma.push_back(predishen);
        }
        imaLiToziNomer[predishen]++;

        for(int i = 1; i < broiTuka; i++){
            int segashen;
            cin>>segashen;

            if(imaLiToziNomer[segashen] == 0){
                nomerataKoitoGiIma.push_back(segashen);
            }
            imaLiToziNomer[segashen]++;

            sasedstvo[predishen].push_back(segashen);
            predishen = segashen;
        }
    }

    /*for(int i = 0; i < nomerataKoitoGiIma.size(); i++){
        cout<<nomerataKoitoGiIma[i]<<" "<<imaLiToziNomer[nomerataKoitoGiIma[i]]<<endl;
    }*/

    bool mojemLi = true;

    for(int i = 0; i < nomerataKoitoGiIma.size(); i++){
        int nomercheTuka = nomerataKoitoGiIma[i];
        if(imaLiToziNomer[nomercheTuka] >= 2){
            dfsZaMarkirane(nomercheTuka, nomercheTuka);

            //cout<<"sega markirah s "<<nomercheTuka<<" i markirani sa "<<endl;

            for(int j = 0; j < segaMarkirani.size(); j++){
                //cout<<segaMarkirani[j]<<" ";
                if(segaMarkirani[j] != nomercheTuka){
                    bool vrashtameLiSe = sreshtameLiGo(segaMarkirani[j], nomercheTuka);

                    if(vrashtameLiSe == true){
                        mojemLi = false;
                        break;
                    }
                }
            }

            if(mojemLi == false){
                break;
            }

            nulirane();
        }
    }

    if(mojemLi == true){
        cout<<1<<endl;
    }else{
        cout<<0<<endl;
    }

    return 0;
}
