// ------------------------------------ zad3 ------------------------------------
#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

const int maxk = 100;
int k;
const int maxv = 20000;
struct Line{
    int mass[maxv];
    int dal;
};

struct Ch{
    int val;
    vector<int> pr;
};

struct UnLine{

    Ch mass[maxv];
    int dal;

    pair<bool, int> sadarjalikade(int ch){
        for(int i=0;i<dal;i++){
            if(ch == mass[i].val)
                return make_pair(true, i);
        }
        return make_pair(false, -1);
    }

    int db = 0;
    bool stavali(int ch, vector<int>* m){
        if(m->size() == 0) return true;
        if(db > 7) return true;

        for (auto it = m->cbegin(); it != m->cend(); it++){
            if(ch == mass[*it].val) return false;
        }

        vector<int> novom;

        for (auto it = m->cbegin(); it != m->cend(); it++){
            int posm = *it;

            for (auto jt = mass[posm].pr.cbegin(); jt != mass[posm].pr.cend(); jt++){
                novom.push_back(*jt);
            }

        }
        db++;
        return stavali(ch, &novom);
    }

};


Line ln[maxk];
UnLine un;


void TransfPr(int indx){
    int i=0;
    for (auto it = un.mass[indx].pr.cbegin(); it != un.mass[indx].pr.cend(); it++){
        un.mass[indx].pr[i] = un.sadarjalikade(*it).second;
        i++;
    }
}

int main()
{
    cin >> k;

    {
        int sdal = 0, sch = 0;
        for(int i =0;i<k;i++){
            cin >> sdal;
            ln[i].dal = sdal;
            for(int j=0;j<sdal;j++){
                cin >> sch;
                ln[i].mass[j] = sch;
            }
        }
    }


    {
        for(int i=0;i<ln[0].dal;i++){
            un.mass[i].val = ln[0].mass[i];
            if(i > 0) un.mass[i].pr.push_back(ln[0].mass[i - 1]);
        }
        un.dal = ln[0].dal;

        for(int i=1;i<k;i++){
            for(int j=0;j<ln[i].dal;j++){
                auto sad = un.sadarjalikade(ln[i].mass[j]);
                if(sad.first == false){
                    un.mass[un.dal].val = ln[i].mass[j];
                    if(j > 0) un.mass[un.dal].pr.push_back(ln[i].mass[j - 1]);
                    un.dal++;
                } else{
                    if(j > 0) un.mass[sad.second].pr.push_back(ln[i].mass[j - 1]);
                }
            }
        }
    }

    for(int i=0;i<un.dal;i++){
        TransfPr(i);
    }

    for(int i=un.dal - 1;i>=0;i--){
            un.db = 0;
        if(un.stavali(un.mass[i].val, &un.mass[i].pr) == false){
            cout << 0;
            return 0;
        }
    }

    cout << 1;
    return 0;
}
