#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define TWOTH 20005
int br;
vector<int> graph[TWOTH];
int occur[TWOTH], degree[TWOTH];
int u[TWOTH];
void dfs(int v)
{
    u[v] = 1;
    for(int att : graph[v]){
        if(u[att] == 1){
            cout << 0 << endl; exit(0);
        }
        if(u[att] == 2) continue;
        dfs(att);
    }
    u[v] = 2;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    for(int i = 0; i < br; ++i){
        int k; cin >> k;
        int last = -1;
        for(int z = 0; z < k; ++z){
            int input; cin >> input;
            occur[input] = 1;
            if(last != -1){
                graph[last].push_back(input);
                degree[input]++;
            }
            last = input;
        }
    }
    for(int i = 1; i < TWOTH; ++i){
        if(!occur[i]) continue;
        if(u[i] == 0){
            dfs(i);
        }
    }
    cout << 1 << endl;
    return 0;
}
