#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 1000005
const int module = 1000000007;
int br, q;
int arr[MAXN];
int lqvo[MAXN];
vector<pair<int, int> > queries;
int prefix[MAXN];
vector<int> st;
vector<int> actpos;
int bsearch(int val)
{
    int l = 0, r = st.size() - 1;
    int lastmid = -1;
    while(l <= r){
        int mid = (l + r) / 2;
        if(st[mid] > val){
            r = mid - 1;
        }
        else{
            lastmid = mid;
            l = mid + 1;
        }
    }
    return lastmid;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); //cout.tie(0);
    cin >> br;
    for(int i = 0; i < br; ++i){
        cin >> arr[i];
    }
    cin >> q;
    for(int i = 0; i < q; ++i){
        int idx, val; cin >> idx >> val;
        queries.push_back({idx, val});
    }
    queries.push_back({br - 1, arr[br - 1]});
    sort(queries.begin(), queries.end());
    int cnt = 0;
    int res = 0;
    int cur = 0;
    for(int i = 0; i < br; ++i){
        //cout << "iterating " << i << endl;
        while(cnt < queries.size() && queries[cnt].first == i){
            //cout << "on query " << queries[cnt].first << ' ' << queries[cnt].second << endl;
            //cout << "!"; for(int q : st) //cout << q << ' '; //cout << "!";
            int val = queries[cnt].second;
            int idx = bsearch(val);
            //cout << "idx is " << idx << endl;
            if(idx != -1){
                //cout << "case 1\n";
                //cout << "adding cur " << cur << endl;
                res += cur; res %= module;
                //cout << "adding 2 " << actpos[idx] << endl;
                res += val * (i - actpos[idx]); res %= module;
                //cout << "adding 3 " << prefix[idx] << endl;
                res += prefix[idx]; res %= module;
            }
            else{
                //cout << "case 2\n";
                //cout << "adding cur " << cur << endl;
                res += cur; res %= module;
                //cout << "adding 2 " << i + 1 << endl;
                res += val * (i + 1); res %= module;
            }
            ++cnt;
        }
        //cout << "here\n";
        while(!st.empty() && st[st.size() - 1] > arr[i]){
            //cout << st[st.size() - 1] << " gets popped\n";
            prefix[st.size() - 1] = 0;
            st.pop_back(); actpos.pop_back();
        }
        int l;
        if(st.empty()) l = i + 1;
        else l = i - (actpos[st.size() - 1]);
        //cout << "l is " << l << endl;
        cur += arr[i] * l; cur %= module;
        st.push_back(arr[i]); actpos.push_back(i);
        int s = 0;
        if(st.size() != 1){
            cur += prefix[st.size() - 2]; cur %= module;
            s += prefix[st.size() - 2]; s %= module;
        }
        //cout << "s is " << s << endl;
        s += l * arr[i]; s %= module;
        //cout << "prefix[st.size() - 1] is " << s << endl;
        prefix[st.size() - 1] = s;
        //cout << "cur is " << cur << endl;
    }
    cout << res << endl;
    return 0;
}
